{
  "name": "nsc-app",
  "private": true,
  "scripts": {
    "start": "umi dev",
    "build": "umi build",
    "postinstall": "umi generate tmp",
    "prettier": "prettier --write '**/*.{js,jsx,tsx,ts,less,md,json}'"
  },
  "gitHooks": {
    "pre-commit": "lint-staged"
  },
  "lint-staged": {
    "*.{js,jsx,less,md,json}": [
      "prettier --write"
    ],
    "*.ts?(x)": [
      "prettier --parser=typescript --write"
    ]
  },
  "dependencies": {
    "@ant-design/pro-layout": "^5.0.12",
    "@bj-nsc/functions": "^1.3.5",
    "@bj-nsc/msn": "^1.0.18",
    "@umijs/preset-react": "2.1.4",
    "antd": "4.19.1",
    "nsc-file": "^2.2.5",
    "lint-staged": "^10.0.7",
    "nsc-request": "^3.0.10",
    "prettier": "^1.19.1",
    "react": "^17.0.1",
    "react-dom": "^17.0.1",
    "umi": "^3.5.26",
    "yorkie": "^2.0.0",
    "nsc-react-component": "^2.8.45"
  },
  "devDependencies": {
    "@umijs/plugin-qiankun": "^2.23.0",
    "typescript": "^4.2.3"
  }
}
